package net.wanji.common.tool.drools;

import net.wanji.common.action.BuiltInActionLibraryUtils;
import net.wanji.common.action.SpringBean;
import com.google.common.collect.Maps;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections4.CollectionUtils;
import org.apache.commons.collections4.MapUtils;
import org.apache.commons.lang3.StringUtils;

import java.util.List;
import java.util.Map;

/**
 * <>
 *
 * @author wanji
 * 2020/6/23 15:26
 */
@Slf4j
public class AviatorTool {

    private static Map<String, Map<String, String>> jarBeanMap = Maps.newHashMap();

    static {

    }

    /**
     * 准备动作库的数据
     *
     * @param moduleName
     * @param beanMap    {"beanName":id}
     */
    public static void readyActionLibrary(String moduleName, Map<String, String> beanMap) {
        if (StringUtils.isBlank(moduleName) || MapUtils.isEmpty(beanMap)) {
            return;
        }
        jarBeanMap.put(moduleName, beanMap);
    }

    public static void init() {
        try {
            registerCommonAction();
//            registerJarAction();
        } catch (Exception e) {
            log.info("******注册Aviator方法异常************");
        } finally {
            //卸载jar
            jarBeanMap.clear();
            AviatorUtils.registerStaticFunctions();
        }
    }

    /**
     * 注册jar里的action
     */
    /*private static void registerJarAction() {
        jarBeanMap.forEach((moduleName, v) -> {
            //获取扩展点
            ModuleManager moduleManager = ServiceBeanContext.getBean("moduleManager");
            Module module = moduleManager.find(moduleName);
            //添加方法到Aviator中
            Map<String, Action> actions = module.getActions();
            for (Map.Entry<String, Action> entry : actions.entrySet()) {
                // actionId actionName action
                AviatorUtils.addStaticFunctions(v.get(entry.getKey()), entry.getKey(), entry.getValue().);
            }
            for (Class<? extends CustomFunction> extensionClass : extensionClasses) {
                Integer actionId = v.get(extensionClass.getSimpleName());
                AviatorUtils.addStaticFunctions(actionId, extensionClass.getSimpleName(), extensionClass);
            }
        });
    }*/

    /**
     * 注册内置公共的action
     */
    private static void registerCommonAction() {
        BuiltInActionLibraryUtils.init();
        List<SpringBean> builtInActions = BuiltInActionLibraryUtils.getBuiltInActions();
        if (CollectionUtils.isEmpty(builtInActions)) {
            return;
        }
        for (SpringBean builtInAction : builtInActions) {
            AviatorUtils.addStaticFunctions(null, builtInAction.getName(), builtInAction.getPath());
        }
    }
}
