package net.wanji.common.tool.estool;

import lombok.Getter;
import lombok.Setter;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

/**
 * @Description:
 * @Author wanji
 * @Date 2019/12/12 17:07
 */
@Getter
@Setter
@Component(value = "esProperties")
@ConfigurationProperties(prefix = EsProperties.ES_PREFIX)
@ConditionalOnProperty(value = "es.cluster.name")
public class EsProperties {

    static final String ES_PREFIX = "es.cluster";

    @Value("${es.cluster.name}")
    private String name;

    @Value("${es.cluster.url}")
    private String url;
}
