package net.wanji.common.tool.wstool;

import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.java_websocket.WebSocket;
import org.java_websocket.client.WebSocketClient;
import org.java_websocket.handshake.ServerHandshake;

import java.net.URI;
import java.net.URISyntaxException;

@Slf4j
public class WebSocketUtil {

    public static boolean connect(String ws) {
        WebSocketClient client = null;
        try {
            URI uri = new URI(ws);
            client = new WebSocketClient(uri) {
                @Override
                public void onOpen(ServerHandshake serverHandshake) {
                }

                @Override
                public void onMessage(String s) {
                    log.info("返回的数据：" + s);
                    JSONObject jo = JSONObject.parseObject(s);
                    String dynamicdata = jo.getString("dynamicdata");
                    if (dynamicdata != null) {
                        JSONObject jo_dynamicdata = JSONObject.parseObject(dynamicdata);
                        String realtimestate = jo_dynamicdata.getString("realtimestate");
                        if (realtimestate.equals("outconnected")) {
                            send("{\"command\":\"closeheadsettochannel\"}");
                        }
                    }
                }

                @Override
                public void onClose(int i, String s, boolean b) {
                }

                @Override
                public void onError(Exception e) {
                    log.error(e.getMessage());
                }


            };
            //建立连接
            client.connect();
            long start=System.currentTimeMillis();
            while(!client.getReadyState().equals(WebSocket.READYSTATE.OPEN)){
                System.out.println("正在连接....");
                if(System.currentTimeMillis()-start>2000){
                    return false;
                }
            }
            return true;
        } catch (URISyntaxException e) {
            log.info(e.getMessage());
            return false;
        } finally {
            client.close();
        }
    }

    public static void main(String []args){
        String socketUrl = "ws://121.40.165.18:8800";
        System.out.println(WebSocketUtil.connect(socketUrl));
    }
}
